package jp.ksksue.tutorial.TWE_Control;

import java.util.Locale;

import jp.ksksue.tutorial.TWE_Control.R;
import jp.ksksue.driver.serial.FTDriver;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.hardware.usb.UsbManager;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.util.Log;

 
public class ChartList extends Activity {
	
	FTDriver mSerial;
	private static final String ACTION_USB_PERMISSION =
			  "jp.ksksue.tutorial.USB_PERMISSION";
	private boolean mRunningMainLoop = false;
	final int mOutputType = 0;
	final boolean SHOW_LOGCAT = false;
	String TAG = "TWE_Line";
	Handler mHandler = new Handler();
	final int SERIAL_BAUDRATE = FTDriver.BAUD115200;
	
	private TextView mTvSerial1,mTvSerial2,mTvSerial3,mTvSerial4,mTvSerial5,mTvSerial6,mTvSerial7;
	private String mText1,mText2,mText3,mText4,mText5,mText6,mText7;
	private boolean mStop = false;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.list);
 
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, R.layout.set);

        mTvSerial1 = (TextView) findViewById(R.id.tvSerial1);
        mTvSerial2 = (TextView) findViewById(R.id.tvSerial2);
        mTvSerial3 = (TextView) findViewById(R.id.tvSerial3);
        mTvSerial4 = (TextView) findViewById(R.id.tvSerial4);
        mTvSerial5 = (TextView) findViewById(R.id.tvSerial5);
        mTvSerial6 = (TextView) findViewById(R.id.tvSerial6);
        mTvSerial7 = (TextView) findViewById(R.id.tvSerial7);
                
        mSerial = new FTDriver((UsbManager)getSystemService(Context.USB_SERVICE));
        
        // [FTDriver] setPermissionIntent() before begin()
        PendingIntent permissionIntent = PendingIntent.getBroadcast(this, 0, new Intent(
                ACTION_USB_PERMISSION), 0);
        mSerial.setPermissionIntent(permissionIntent);
        
        if(mSerial.begin(SERIAL_BAUDRATE)) {
	    	mainloop();
	        Toast.makeText(this, "ڑ܂", Toast.LENGTH_SHORT).show();
	    } 
		else {
	        Toast.makeText(this, "ڑł܂", Toast.LENGTH_SHORT).show();
	        }
        
        
        // ACeǉ܂
        adapter.add("dOt");
        adapter.add("LQIOt");
        adapter.add("xOt1(LM61BIZΉ)");
        adapter.add("xOt2(LM61BIZΉ)");
        adapter.add("xOt3(LM61BIZΉ)");
        adapter.add("xOt4(LM61BIZΉ)");
        ListView listView = (ListView) findViewById(R.id.listview);
        // A_v^[ݒ肵܂
        listView.setAdapter(adapter);
        // Xgr[̃ACeNbNꂽɌĂяoR[obNXi[o^܂
        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                    int position, long id) {
                ListView listView = (ListView) parent;
                // NbNꂽACe擾܂
                String item = (String) listView.getItemAtPosition(position);
                if(item == "dOt"){
                Intent intent=new Intent(ChartList.this,  Voltage.class);
                startActivity(intent);
                }
                if(item == "LQIOt"){
                    Intent intent=new Intent(ChartList.this,  LQI.class);
                    startActivity(intent);
                    }
                if(item == "xOt1(LM61BIZΉ)"){
                    Intent intent=new Intent(ChartList.this,  Temp01.class);
                    startActivity(intent);
                    }
                if(item == "xOt2(LM61BIZΉ)"){
                    Intent intent=new Intent(ChartList.this,  Temp02.class);
                    startActivity(intent);
                    }
                if(item == "xOt3(LM61BIZΉ)"){
                    Intent intent=new Intent(ChartList.this,  Temp03.class);
                    startActivity(intent);
                    }
                if(item == "xOt4(LM61BIZΉ)"){
                    Intent intent=new Intent(ChartList.this,  Temp04.class);
                    startActivity(intent);
                    }
            }
            
        });
        // Xgr[̃ACeIꂽɌĂяoR[obNXi[o^܂
        listView.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view,
                    int position, long id) {
                ListView listView = (ListView) parent;
                // IꂽACe擾܂
                String item = (String) listView.getSelectedItem();
                Toast.makeText(ChartList.this, item, Toast.LENGTH_LONG).show();
            }
            @Override
            public void onNothingSelected(AdapterView<?> parent) {
            }
        });
    }

    private void mainloop() {
    	
    	mRunningMainLoop = true;
		new Thread(mLoop).start();
    }
    
	private Runnable mLoop = new Runnable() {
		@Override
		public void run() {
        int i,len;
        double ondo1, ondo2, ondo3, ondo4;

        // [FTDriver] Create Read Buffer
        byte[] rbuf = new byte[4096]; // 1byte <--slow-- [Transfer Speed] --fast--> 4096 byte
        for(;;){
        // [FTDriver] Read from USB Serial
        len = mSerial.read(rbuf);
        String str1 = new String(rbuf);
      
        String new_str1 = str1.substring(9,11);
        String new_str2 = str1.substring(27,31);
        String new_str3 = str1.substring(33,35);
        String new_str4 = str1.substring(37,39);
        String new_str5 = str1.substring(39,41);
        String new_str6 = str1.substring(41,43);
        String new_str7 = str1.substring(43,45);
        
      
		if(len > 0) {
			if(SHOW_LOGCAT) { Log.i(TAG,"Read  Length : "+len); }
			mText1 = (String) mTvSerial1.getText();
			mText2 = (String) mTvSerial2.getText();
			mText3 = (String) mTvSerial3.getText();
			mText4 = (String) mTvSerial4.getText();
			mText5 = (String) mTvSerial5.getText();
			mText6 = (String) mTvSerial6.getText();
			mText7 = (String) mTvSerial7.getText();
			
			try{ //G[oȏLq
		          String x,y;
					int a,b;
					
					
					x = new_str1.toLowerCase(Locale.ENGLISH);
			        y = new_str2.toLowerCase(Locale.ENGLISH);

					a = Integer.parseInt(x, 16);	
					b = Integer.parseInt(y, 16);
					
						  			
			
			for(i=0;i<len;++i) {
				if(SHOW_LOGCAT) { Log.i(TAG,"Read  Data["+i+"] : "+rbuf[i]); }
							
				
				 if (rbuf[i] == 0x0A) {
					if(a>0 && a<255){
						mText1 = "" +String.valueOf(a) +"\n";}					 			 
					if(b>0){	
					    mText2 = "" +String.valueOf(b) +"\n";}				 
						mText3 = "" +new_str3 +"\n";

						//mText4 = "" +new_str4 +"\n";
						if(!(new_str4.equals("FF"))) {
							ondo1 = ((Integer.parseInt(new_str4, 16))*16);
							ondo1 = (ondo1/10)-60 ;	
							mText4 = "" +String.format("%.1f", ondo1) +"\n";	
						}
						
						//mText5 = "" +new_str5 +"\n";
						if(!(new_str5.equals("FF"))) {
							ondo2 = ((Integer.parseInt(new_str5, 16))*16);
							ondo2 = (ondo2/10)-60 ;
							//mText5 = "" +ondo1 +"\n";	
							mText5 = "" +String.format("%.1f", ondo2) +"\n";	
						}
						
						//mText6 = "" +new_str6 +"\n";
						if(!(new_str6.equals("FF"))) {
							ondo3 = ((Integer.parseInt(new_str6, 16))*16);
							ondo3 = (ondo3/10)-60 ;
							mText6 = "" +String.format("%.1f", ondo3) +"\n";	
						}
						
						//mText7 = "" +new_str7 +"\n";
						if(!(new_str7.equals("FF"))) {
							ondo4 = ((Integer.parseInt(new_str7, 16))*16);
							ondo4 = (ondo4/10)-60 ;
							//mText4 = "" +ondo1 +"\n";	
							mText7 = "" +String.format("%.1f", ondo4) +"\n";	
						}	
						
					 }			 		
				
			}
			
		}
		catch(NumberFormatException nfe)
		{
		  //G[ȍLq
		}
			
			mHandler.post(new Runnable() {
				public void run() {
					mTvSerial1.setText(mText1);
					mTvSerial2.setText(mText2);
					mTvSerial3.setText(mText3);
					mTvSerial4.setText(mText4);
					mTvSerial5.setText(mText5);
					mTvSerial6.setText(mText6);
					mTvSerial7.setText(mText7);
				}
			});
		}
		
		try {
			Thread.sleep(50);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		if(mStop) {
			mRunningMainLoop = false;
			return;
		}
	}
}
};



}

